﻿#include <iostream>
#include <vector>
#include <set>
using namespace std;
vector<vector<int>> graph;
vector<int> ans;
vector<int> saved;
const long long inf = 1e9;
void dfs(int v, int s, int h, int p = -1) {
    if (s <= h && h != 0) {
        saved.push_back(v+1);
    }
    for (int u : graph[v]) {
        if (u != p && s < h) {
            dfs(u, s+1, h, v);
        }
    }
}


vector<int> dijkstra(int s, int n) {
    vector<int> d(n, inf);
    d[s] = 0;
    set< pair<int, int> > q;
    q.insert({0, s});
    while (!q.empty()) {
        int v = q.begin()->second;
        q.erase(q.begin());
        for (auto u : graph[v]) {
            int w = 1;
            if (d[u] > d[v] + w) {
                q.erase({ d[u], u });
                d[u] = d[v] + w;
                q.insert({ d[u], u });
            }
        }
    }
    return d;
}



int main() {
    int n, m, k;
    cin >> n >> m >> k;
    for (int i = 0; i < n; i++) {
        vector<int> h;
        graph.push_back(h);
    }
    vector<int> powers(n, 0);
    for (int i = 0; i < m; i++) {
        int a, b;
        cin >> a >> b;
        graph[a-1].push_back(b-1);
        graph[b-1].push_back(a-1);

    }
    for (int i = 0; i < k; i++) {
        int a, b;
        cin >> a >> b;
        powers[a-1] = b;
    }
    for (int i = 0; i < n; i++) {
        if (powers[i] != 0) {
            vector <int> d = dijkstra(i, n);
            for (int j = 0; j < n; j++) {
                if (powers[i] >= d[j]) {
                    saved.push_back(j+1);
                }
            }
        }
    }
    set<int> set;
    for (int i = 0; i < saved.size(); i++) {
        set.insert(saved[i]);
    }
    std::set<int>::iterator iter = set.begin();
    cout << set.size() << endl;
    for (iter; iter != set.end(); iter++) {
        cout << *iter << ' ';
    }
}
