﻿#include <iostream>
#include <vector>
#include <set>
using namespace std;
vector<vector<long long>> graph;
vector<long long> ans;
vector<long long> saved;
const long long inf = 1e9;
void dfs(long long v, long long s, long long h, long long p = -1) {
    if (s <= h && h != 0) {
        saved.push_back(v+1);
    }
    for (long long u : graph[v]) {
        if (u != p && s < h) {
            dfs(u, s+1, h, v);
        }
    }
}


vector<long long> dijkstra(long long s, long long n) {
    vector<long long> d(n, inf);
    d[s] = 0;
    set< pair<long long, long long> > q;
    q.insert({0, s});
    while (!q.empty()) {
        long long v = q.begin()->second;
        q.erase(q.begin());
        for (auto u : graph[v]) {
            long long w = 1;
            if (d[u] > d[v] + w) {
                q.erase({ d[u], u });
                d[u] = d[v] + w;
                q.insert({ d[u], u });
            }
        }
    }
    return d;
}



int main() {
    long long n, m, k;
    cin >> n >> m >> k;
    for (long long i = 0; i < n; i++) {
        vector<long long> h;
        graph.push_back(h);
    }
    vector<long long> powers(n, 0);
    for (long long i = 0; i < m; i++) {
        long long a, b;
        cin >> a >> b;
        graph[a-1].push_back(b-1);
        graph[b-1].push_back(a-1);

    }
    for (long long i = 0; i < k; i++) {
        long long a, b;
        cin >> a >> b;
        powers[a-1] = b;
    }
    for (long long i = 0; i < n; i++) {
        if (powers[i] != 0) {
            vector <long long> d = dijkstra(i, n);
            for (long long j = 0; j < n; j++) {
                if (powers[i] >= d[j]) {
                    saved.push_back(j+1);
                }
            }
        }
    }
    set<long long> set;
    for (long long i = 0; i < saved.size(); i++) {
        set.insert(saved[i]);
    }
    std::set<long long>::iterator iter = set.begin();
    cout << set.size() << endl;
    for (iter; iter != set.end(); iter++) {
        cout << *iter << ' ';
    }
}
